{
  description = "An opionated Postgres library";

  inputs.nixpkgs.url = "github:nixos/nixpkgs/release-25.05";
  inputs.flake-utils.url = "github:numtide/flake-utils";

  outputs = { self, nixpkgs, flake-utils }: flake-utils.lib.eachDefaultSystem (system:
    let
      pkgs = import nixpkgs { inherit system; };
      opium = pkgs.haskellPackages.developPackage {
        root = ./.;
        modifier = drv:
          pkgs.haskell.lib.addBuildTools drv [
            pkgs.cabal-install
            pkgs.haskellPackages.implicit-hie
            pkgs.haskell-language-server
          ];
      };
    in {
      packages.opium = pkgs.haskell.lib.overrideCabal opium {
        # Currently the tests require a running Postgres instance.
        # This is not automated yet, so don't export the tests.
        doCheck = false;
      };

      devShells.default = opium.env;
    }
  );
}
